#include    <stdio.h>
#include    <stdlib.h>
#include    <string.h>
#include    <ctype.h>
#include    <time.h>
#include    <utime.h>
#include    <sys/stat.h>

#define	Bufferd_Recive	GET_AUX
#define	Bufferd_Send(c)	BUF_SEND(c)
#define	Bufferd_Flush	BUF_FLUSH

int	Bufferd_Recive();
void	Bufferd_Send(char ch);
void	Bufferd_Flush();

int	ST_Check_Abort()
{
    return 0;
}

char	*basename(char *file);

#define	TRUE	1
#define	FALSE	0
#define	ERR	(-1)

#define	UNSIG	    unsigned short

#define	WRITE_OP     "w"
#define	READ_OP	     "r"
#define	UPDATE_OP    "r+"

#define	SA_Next_to_ACK	    SA_NX_AK
#define	SA_Next_to_Fill	    SA_NX_FL
#define	Update_Quote_Table  UP_QU_TB

#define	Def_BS		8	    /* Default Packet size		*/
#define Max_SA		32          /* Maximum number of waiting Packets */
#define Max_Buf_Size (Def_BS*128+8) /* Largest data block we can handle */

#define Def_WS          1           /* I can send 2 Packets ahead       */
#define Def_WR          1           /* I can receive single send-ahead  */
#define Def_CM          1           /* I can handle CRC                 */
#define Def_DQ          1           /* I can handle non-quoted NUL      */
#define Def_UR          0           /* I can Not handle Upload Recovery */
#define	Def_DR		2	    /* I can Not handle download Recov	*/
#define Def_FI          1           /* I can handle File Information 	*/

#define max_Errors     	10

/* Receive States */

#define   R_Get_DLE       0
#define   R_Get_B         1
#define   R_Get_Seq       2
#define   R_Get_Data      3
#define   R_Get_Check     4
#define   R_Send_ACK      5
#define   R_Timed_Out     6
#define   R_Success       7

/* Send States */

#define   S_Get_DLE       1
#define   S_Get_Num       2
#define   S_Have_ACK      3
#define   S_Get_Packet    4
#define   S_Skip_Packet   5
#define   S_Timed_Out     6
#define   S_Send_NAK      7
#define   S_Send_ENQ      8
#define   S_Send_Data     9

/* Other Constants */

#define   dle   16
#define   etx   03
#define   nak   21
#define   enq   05

typedef struct {
	int	seq;    		/* Packet's sequence number  */
	int	num;    		/* Number of bytes in Packet */
	char	buf[Max_Buf_Size]; 	/* Actual Packet data        */
	} buf_type;

static	__off_t	R_FileSize;
static	time_t	R_FileCTime;
static	time_t	R_FileMTime;
static	char	R_TrueName[258];

static	int	seq_num;
static	UNSIG	checksum;
static  char   	His_WS,His_WR,His_BS,His_CM;
static	char	His_QS[8];
static	char	His_DR,His_UR,His_FI;
static	char	Our_WS,Our_WR,Our_BS,Our_CM;
static	char	Our_QS[8];
static	char	Our_DR,Our_UR,Our_FI;
static	int	B_Plus;
static	int	Use_CRC;
static	int	Buffer_Size = 512;
static	int	SA_Max;
static	int	Max_Inc;
static	int	SA_Error_Count;
static	char	Quote_Table[256];
static	char	DQ_Full[]={
			0xff, 0xff, 0xff, 0xff,
	   		0xff, 0xff, 0xff, 0xff };
static	char	DQ_Default[]={
        		0x14, 0x00, 0xd4, 0x00,
         		0x00, 0x00, 0x00, 0x00 };
static	char	DQ_Minimal[]={
        		0x14, 0x00, 0xd4, 0x00,
        		0x00, 0x00, 0x00, 0x00 };
static	char	DQ_Extended[]={
			0x14, 0x00, 0xd4, 0x00,
		        0x00, 0x00, 0x50, 0x00 };

static	int	R_Size = 0;
static	int	ch;
static	int	Packet_Received,masked;
static	buf_type SA_Buf[Max_SA+1];
static	int     SA_Next_to_ACK;
static	int     SA_Next_to_Fill;
static	int     SA_Waiting;
static	int    	Aborting;
static	char	R_buffer[Max_Buf_Size];
static	UNSIG	crc_16;
static	UNSIG	crc_table[] = {
        0x0000, 0x1021, 0x2042, 0x3063, 0x4084, 0x50A5, 0x60C6, 0x70E7,
        0x8108, 0x9129, 0xA14A, 0xB16B, 0xC18C, 0xD1AD, 0xE1CE, 0xF1EF,
        0x1231, 0x0210, 0x3273, 0x2252, 0x52B5, 0x4294, 0x72F7, 0x62D6,
        0x9339, 0x8318, 0xB37B, 0xA35A, 0xD3BD, 0xC39C, 0xF3FF, 0xE3DE,
        0x2462, 0x3443, 0x0420, 0x1401, 0x64E6, 0x74C7, 0x44A4, 0x5485,
        0xA56A, 0xB54B, 0x8528, 0x9509, 0xE5EE, 0xF5CF, 0xC5AC, 0xD58D,
        0x3653, 0x2672, 0x1611, 0x0630, 0x76D7, 0x66F6, 0x5695, 0x46B4,
        0xB75B, 0xA77A, 0x9719, 0x8738, 0xF7DF, 0xE7FE, 0xD79D, 0xC7BC,
        0x48C4, 0x58E5, 0x6886, 0x78A7, 0x0840, 0x1861, 0x2802, 0x3823,
        0xC9CC, 0xD9ED, 0xE98E, 0xF9AF, 0x8948, 0x9969, 0xA90A, 0xB92B,
        0x5AF5, 0x4AD4, 0x7AB7, 0x6A96, 0x1A71, 0x0A50, 0x3A33, 0x2A12,
        0xDBFD, 0xCBDC, 0xFBBF, 0xEB9E, 0x9B79, 0x8B58, 0xBB3B, 0xAB1A,
        0x6CA6, 0x7C87, 0x4CE4, 0x5CC5, 0x2C22, 0x3C03, 0x0C60, 0x1C41,
	0xEDAE, 0xFD8F, 0xCDEC, 0xDDCD, 0xAD2A, 0xBD0B, 0x8D68, 0x9D49,
        0x7E97, 0x6EB6, 0x5ED5, 0x4EF4, 0x3E13, 0x2E32, 0x1E51, 0x0E70,
        0xFF9F, 0xEFBE, 0xDFDD, 0xCFFC, 0xBF1B, 0xAF3A, 0x9F59, 0x8F78,
        0x9188, 0x81A9, 0xB1CA, 0xA1EB, 0xD10C, 0xC12D, 0xF14E, 0xE16F,
        0x1080, 0x00A1, 0x30C2, 0x20E3, 0x5004, 0x4025, 0x7046, 0x6067,
        0x83B9, 0x9398, 0xA3FB, 0xB3DA, 0xC33D, 0xD31C, 0xE37F, 0xF35E,
        0x02B1, 0x1290, 0x22F3, 0x32D2, 0x4235, 0x5214, 0x6277, 0x7256,
        0xB5EA, 0xA5CB, 0x95A8, 0x8589, 0xF56E, 0xE54F, 0xD52C, 0xC50D,
        0x34E2, 0x24C3, 0x14A0, 0x0481, 0x7466, 0x6447, 0x5424, 0x4405,
        0xA7DB, 0xB7FA, 0x8799, 0x97B8, 0xE75F, 0xF77E, 0xC71D, 0xD73C,
        0x26D3, 0x36F2, 0x0691, 0x16B0, 0x6657, 0x7676, 0x4615, 0x5634,
        0xD94C, 0xC96D, 0xF90E, 0xE92F, 0x99C8, 0x89E9, 0xB98A, 0xA9AB,
        0x5844, 0x4865, 0x7806, 0x6827, 0x18C0, 0x08E1, 0x3882, 0x28A3,
        0xCB7D, 0xDB5C, 0xEB3F, 0xFB1E, 0x8BF9, 0x9BD8, 0xABBB, 0xBB9A,
        0x4A75, 0x5A54, 0x6A37, 0x7A16, 0x0AF1, 0x1AD0, 0x2AB3, 0x3A92,
        0xFD2E, 0xED0F, 0xDD6C, 0xCD4D, 0xBDAA, 0xAD8B, 0x9DE8, 0x8DC9,
        0x7C26, 0x6C07, 0x5C64, 0x4C45, 0x3CA2, 0x2C83, 0x1CE0, 0x0CC1,
        0xEF1F, 0xFF3E, 0xCF5D, 0xDF7C, 0xAF9B, 0xBFBA, 0x8FD9, 0x9FF8,
        0x6E17, 0x7E36, 0x4E55, 0x5E74, 0x2E93, 0x3EB2, 0x0ED1, 0x1EF0
	};

static	void Send_Failure();

static void Clear_Quote_Table()
{
    memset(Quote_Table,0,256);
}
static void Update_Quote_Table (Quote_Set)
char	*Quote_Set;
{
    int	   i, j, k;
    char   b, c;

    c = 0x40;
    k = 0x00;

    for ( i = 0 ; i < 8 ; i++ ) {
	if ( i == 4 ) {
	    c = 0x60;
	    k = 0x80;
	}

	b = Quote_Set[i];

	for ( j = 0 ; j < 8 ; j++ ) {
	    if ( (b & 0x80) != 0)
		Quote_Table[k] = c;

	    b <<= 1;
	    c++;
	    k++;
	}
    }
}
static	int	Init_CRC (value)
int	value;
{
    return( crc_16 = value );
}
static	UNSIG	Upd_CRC (value)
UNSIG	value;
{
    value &= 0xFF;
    crc_16 = crc_table [((crc_16 >> 8) ^ (value)) & 0xff] ^ (crc_16 << 8);
    return( crc_16 );
}
static	void do_checksum (c)
int	c;
{
    c &= 0xFF;
    if ( B_Plus && Use_CRC )
    	checksum = Upd_CRC (c);
    else {
       	checksum <<= 1;
	if (checksum > 255)
    	    checksum = (checksum & 0xff) + 1;
	checksum += c;
	if (checksum > 255)
    	    checksum = (checksum & 0xff) + 1;
    }
}
static void send_masked_byte (c)
int	c;
{
    c &= 0xff;

    if (Quote_Table [c] != 0) {
    	Bufferd_Send(dle);
	Bufferd_Send(Quote_Table[c]);
    } else
	Bufferd_Send(c);
}
static void Send_ACK()
{
    Bufferd_Send(dle);
    Bufferd_Send(seq_num + '0');
    Bufferd_Flush();

#ifdef	DEBUG
    debug("Send ACK #%d\n",seq_num);
#endif
}
static void Send_NAK()
{
    Bufferd_Send(nak);
    Bufferd_Flush();
#ifdef	DEBUG
    debug("Send NAK\n");
#endif
}
static void Send_ENQ()
{
    Bufferd_Send(enq);
    Bufferd_Flush();
#ifdef	DEBUG
    debug("Send ENQ\n");
#endif
}
static int read_byte()
{
    int     chx;
    int     Hiber;
    time_t  start,now;

    if ( ST_Check_Abort() )
	return FALSE;

    if ( (chx = Bufferd_Recive()) != ERR )
	goto ENDOF;

    time(&start);

    if ( !Aborting )
	Hiber = 30;
    else
	Hiber = 15;

    while ( (chx = Bufferd_Recive()) == ERR ) {
        time(&now);
	if ( (now - start) >= Hiber ) {
	    return( FALSE );
	}
    }

ENDOF:
    ch = chx & 0xFF;
    return(TRUE);
}
static int read_masked_byte()
{
    masked = FALSE;

    if ( read_byte() == FALSE )
    	return(FALSE);

    if ( ch == dle ) {
	if (read_byte() == FALSE)
    	    return(FALSE);
	if ( ch < 0x60 )
	    ch &= 0x1f;
	else
	    ch = (ch & 0x1F) | 0x80;
	masked = TRUE;
    }
    return(TRUE);
}
static	int Incr_Seq (value)
int	value;
{
    if ( value == 9 )
	return( 0);
    else
	return(value + 1);
}
static	int	Read_Packet (Lead_in_Seen, From_Send_Packet)
int	Lead_in_Seen;
int	From_Send_Packet;
{
    int	    State,
	    next_seq,
	    block_num,
	    errors,
	    new_cks;
    int	    i;
    int	    NAK_Sent;

    if ( Packet_Received ) {
	Packet_Received = FALSE;
	return( TRUE);
    }

    NAK_Sent = FALSE;
    memset(R_buffer,0,Buffer_Size);
    next_seq = (seq_num +  1) % 10;
    errors = 0;
    i = 0;

    if ( Lead_in_Seen )
	State = R_Get_Seq;
    else
	State = R_Get_DLE;

    while( TRUE ) {
	switch ( State ) {
	case R_Get_DLE :
	    if ( ST_Check_Abort() && !Aborting ) {
/********************************************************
	        Send_Failure ("AAborted by user");
*********************************************************/
		return(FALSE);
	    }
	    if ( !read_byte() )
		State = R_Timed_Out;
	    else if ((ch & 0x7F) == dle )
		State = R_Get_B;
	    else if ((ch & 0x7F) == enq )
		State = R_Send_ACK;
	    break;

	case R_Get_B :
	    if ( !read_byte() )
		State = R_Timed_Out;
	    else if ((ch & 0x7F) == 'B')
		State = R_Get_Seq;
	    else if (ch == enq)
		State = R_Send_ACK;
	    else if (ch == ';') {
		State = R_Get_DLE;
	    } else
		State = R_Get_DLE;
	    break;

	case R_Get_Seq :
	    if ( !read_byte() )
		State = R_Timed_Out;
	    else if ( ch == enq)
		State = R_Send_ACK;
	    else {
		if (B_Plus && Use_CRC)
		    checksum = Init_CRC(0xffff);
		else
		    checksum = 0;
		block_num = ch - '0';
		do_checksum (ch);
		i = 0;
		State = R_Get_Data;
	    }
	    break;

	case R_Get_Data :
	    if ( !read_masked_byte() )
		State = R_Timed_Out;
	    else if ( (ch == etx) && !masked ) {
		do_checksum (etx);
		State = R_Get_Check;
	    } else if ( i < Max_Buf_Size ) {
		R_buffer[i] = ch;
		i++;
		do_checksum (ch);
	    }
	    break;

	case R_Get_Check :
	    if ( !read_masked_byte() )
		State = R_Timed_Out;
	    else {
		if ( B_Plus && Use_CRC ) {
		    checksum = Upd_CRC(ch);
		    if ( !read_masked_byte() )
			new_cks = checksum ^ 0xff;
		    else {
			checksum = Upd_CRC(ch);
			new_cks = 0;
	    	    }
		} else
		    new_cks = ch;

		if (new_cks != checksum) {
		    State = R_Timed_Out;
		} else if (R_buffer[0] == 'F') /* Watch for Failure Packet */
		    State = R_Success;	 /* which is accepted regardless */
		else if (block_num == seq_num) /* Watch for duplicate block */
		    State = R_Send_ACK; /* Simply ACK it */
		else if (block_num != next_seq)
		    State = R_Timed_Out; /* Bad seq num */
		else
		    State = R_Success;
	    }
	    break;

	case R_Timed_Out :
	    errors++;
	    if ( (errors > max_Errors) || (From_Send_Packet) )
		return( FALSE );
	    if ( !NAK_Sent || !B_Plus ) {
		NAK_Sent = TRUE;
		Send_NAK();
	    }
	    State = R_Get_DLE;
	    break;

	case R_Send_ACK :
	    if ( !Aborting )
		Send_ACK();
	    State = R_Get_DLE;        /* wait for the next block */
    	    break;

	case R_Success :
	    if ( !Aborting )
		seq_num = block_num;
	    R_Size = i;

#ifdef	DEBUG
    debug("Read Packet #%d %d Byte\n",block_num,R_Size);
#endif
	    return(TRUE);
	}
    }
} /* Read_Packet */

static	void Send_Data (BuffeR_Number)
int	BuffeR_Number;
{
    int	    i;
    buf_type *p;

    p = &SA_Buf[BuffeR_Number];

    if (B_Plus && Use_CRC)
	checksum = Init_CRC (0xffff);
    else
	checksum = 0;

    Bufferd_Send (dle);
    Bufferd_Send ('B');
    Bufferd_Send (p->seq + '0');
    do_checksum (p->seq + '0');

    for (i = 0; i <= p->num; i++ ) {
	send_masked_byte (p->buf [i]);
	do_checksum (p->buf[i]);
    }

    Bufferd_Send (etx);
    do_checksum (etx);

    if (B_Plus && Use_CRC)
	send_masked_byte (checksum >> 8);

    send_masked_byte (checksum);

    Bufferd_Flush();

#ifdef	DEBUG
    debug("send packet #%d %d byte %04x\n",p->seq,p->num,checksum);
#endif

}
static	int	Incr_SA (Old_Value)
int	Old_Value;
{
    if (Old_Value == Max_SA)
	return(0);
    else
	return(Old_Value + 1);
}

#define	  Get_First_DLE     1
#define	  Get_First_Digit   2
#define	  Get_Second_DLE    3
#define	  Get_Second_Digit  4

static	int	ReSync()
{
    int	    State,Digit_1;

    Bufferd_Send (enq);     /* Send <ENQ><ENQ> */
    Bufferd_Send (enq);
    Bufferd_Flush();
    State = Get_First_DLE;

    while(1) {
	switch (State) {

	case Get_First_DLE :
	    if ( !read_byte() )
		return(-1);
	    if ( ch == dle )
		State = Get_First_Digit;
	    break;

	case Get_First_Digit :
	    if ( !read_byte() )
		return(-1);
	    if ( (ch >= '0') && (ch <= '9') ) {
		Digit_1 = ch;
		State = Get_Second_DLE;
	    } else if (ch == 'B')
		return( ch );
	    break;

	case Get_Second_DLE :
	    if ( !read_byte() )
		return(-1);
	    if ( ch == dle )
		State = Get_Second_Digit;
	    break;

	case Get_Second_Digit :
	    if ( !read_byte() )
		return(-1);
	    if ( (ch >= '0') && (ch <= '9') ) {
		if (Digit_1 == ch  )
		    return(ch);
		else if (ch == 'B')
		    return( ch );
		else {
		    Digit_1 = ch;
		    State = Get_Second_DLE;
	 	}
	    } else
		State = Get_Second_DLE;
	    break;

	} /* case */
    }  /* while TRUE */
}

static	int	Get_ACK()
{
    int	    State,
	    errors,
	    block_num,
	    i;
    int	    Sent_ENQ;
    int	    SA_Index;

    Packet_Received = FALSE;
    errors = 0;
    Sent_ENQ = FALSE;
    State = S_Get_DLE;

    while ( 1 ) {
	switch (State) {
	case S_Get_DLE :
	    if ( ST_Check_Abort() && !Aborting ) {
/********************************************************
		Send_Failure ("AAborted by user");
*********************************************************/
		return(FALSE);
	    }
	    if ( !read_byte() )
		State = S_Timed_Out;
	    else {
		if ( ch == dle )
		    State = S_Get_Num;
		else if (ch == nak )
		    State = S_Send_ENQ;
		else if (ch == etx )
		    State = S_Send_NAK;
	    }
	    break;

	case S_Get_Num :
	    if (!read_byte() )
		State = S_Timed_Out;
	    else if ( (ch >= '0') && (ch <= '9') )
		State = S_Have_ACK;		/* Received ACK */
	    else if ( ch == 'B' ) {
		if (!Aborting)
		    State = S_Get_Packet;	/* Try to receive a Packet */
		else
		    State = S_Skip_Packet;  	/* Try to skip a Packet */
	    } else if (ch == nak)
		State = S_Send_ENQ;
	    else if (ch == ';')
		State = S_Get_DLE;
	    else
		State = S_Timed_Out;
	    break;

	case S_Get_Packet :
	    if ( Read_Packet (TRUE, TRUE) ) {
		Packet_Received = TRUE;
		switch(R_buffer[0]) {
		case 'F':
		    Send_ACK();
		    return(FALSE);
		case 'T':
		    if ( Our_DR > 0 && R_buffer[1] == 'r' )
		        return(FALSE);
		}
		State = S_Get_DLE;     /* Stay here to find the ACK */
	    } else
		State = S_Get_DLE;
	    break;

	case S_Skip_Packet :    /* Skip an incoming Packet */
	    if (!read_byte())
		State = S_Timed_Out;
	    else if (ch == etx ) {
		if (!read_masked_byte())
		    State = S_Timed_Out;
		else if (!Use_CRC)
		    State = S_Get_DLE;
		else if (!read_masked_byte())
		    State = S_Timed_Out;
		else
		    State = S_Get_DLE;
	    }
	    break;

	case S_Have_ACK :
	    block_num = ch - '0';

#ifdef	DEBUG
    debug("Get ACK #%d (%d)\n",block_num,SA_Buf[SA_Next_to_ACK].seq);
#endif

	    if ( SA_Buf[SA_Next_to_ACK].seq == block_num  ) {
		SA_Next_to_ACK = Incr_SA (SA_Next_to_ACK);
		SA_Waiting = SA_Waiting - 1;
		if (SA_Error_Count > 0 )
		    SA_Error_Count--;
		if ( Our_WS != 0 && SA_Max < Max_SA && ++Max_Inc > 3 ) {
		    SA_Max++;
		    Max_Inc = 0;
		}
		return(TRUE);

	    } else if ( (SA_Buf[Incr_SA(SA_Next_to_ACK)].seq == block_num) &&
			 SA_Waiting == 2) {
		SA_Next_to_ACK = Incr_SA (SA_Next_to_ACK);
		SA_Next_to_ACK = Incr_SA (SA_Next_to_ACK);
		SA_Waiting = SA_Waiting - 2;
		if (SA_Error_Count > 0)
		    SA_Error_Count--;
		if ( Our_WS != 0 && SA_Max < Max_SA && ++Max_Inc > 3 ) {
		    SA_Max++;
		    Max_Inc = 0;
		}
 		return(TRUE);

	    } else if ( SA_Buf[SA_Next_to_ACK].seq == Incr_Seq(block_num) ) {
		if ( Sent_ENQ )
		    State = S_Send_Data; /* Remote missed first block */
		else
		    State = S_Get_DLE;       /* Duplicate ACK */
	    } else {
		if ( !Aborting )        /* While aborting, ignore any */
		    State = S_Timed_Out; /* ACKs that have been sent   */
		else
		    State = S_Get_DLE;	/* which are not for the failure */
	    }       	                            /* Packet. */
	    Sent_ENQ = FALSE;
	    break;

	case S_Timed_Out :
#ifdef	DEBUG
    debug("Timed Out ");
#endif
	    State = S_Send_ENQ;
	    break;

	case S_Send_NAK :
	    errors++;
	    if (errors > max_Errors)
		return(FALSE);
	    Send_NAK();
	    State = S_Get_DLE;
	    break;

	case S_Send_ENQ :

#ifdef	DEBUG
    debug("Get NAK\n");
#endif

	    errors++;
	    if ( (errors > max_Errors) || (Aborting && (errors > 3)) )
		return(FALSE);

	    ch = ReSync();
	    if ( ch == (-1) )
		State = S_Get_DLE;
	    else if (ch == 'B') {
		if( !Aborting )
		    State = S_Get_Packet;   /* Try to receive a Packet */
		else
		    State = S_Skip_Packet;  /* Try to skip a Packet */
	    } else
		State = S_Have_ACK;
	    Sent_ENQ   = TRUE;
	    break;

	case S_Send_Data :
	    Max_Inc = (-3);
	    if ( SA_Max > 2 )
		SA_Max = 2;
	    if ( (SA_Error_Count += 2) >= 6 )
	        SA_Max = 1;
	    SA_Index = SA_Next_to_ACK;
	    for ( i = 1 ; i <= SA_Waiting ; i++ ) {
		Send_Data (SA_Index);
       		SA_Index = Incr_SA (SA_Index);
	    }
	    State = S_Get_DLE;
	    Sent_ENQ = FALSE;
	    break;
	}
   }
} /* Get_ACK */

static	int	send_Packet (size)
int	size;
{
    while ( SA_Waiting >= SA_Max ) {
	if ( !Get_ACK() )
	    return(FALSE);
    }

    seq_num = Incr_Seq (seq_num);
    SA_Buf [SA_Next_to_Fill].seq = seq_num;
    SA_Buf [SA_Next_to_Fill].num = size;
    Send_Data (SA_Next_to_Fill);
    SA_Next_to_Fill = Incr_SA (SA_Next_to_Fill);
    SA_Waiting++;
    return(TRUE);
}

static	int	SA_Flush()
{
    while ( SA_Waiting > 0 ) {
	if ( !Get_ACK() )
	    return(FALSE);
    }
    return( TRUE );
}

static	void Send_Failure (Reason)
char	Reason[];
{
    int	    i;
    buf_type *p;

    SA_Next_to_ACK = 0;
    SA_Next_to_Fill = 0;
    SA_Waiting = 0;
    Aborting   = TRUE;          /* Inform Get_ACK we're aborting ]*/

    p = &SA_Buf [0];
    p->buf [0] = 'F';
    for ( i = 1 ; i <= strlen(Reason) ; i++ )
	p->buf [i] = (Reason [i]);

    if ( send_Packet (strlen(Reason)) )
	SA_Flush();   /* Gotta wait for the Initiator to ACK it */
}

static	void	Transport_Parameters()
{
    int	    Quote_Set_Present;
    int     i;
    buf_type *p;

    Our_WS = 0;
    Our_WR = 0;
    Our_BS = 4;
    Our_CM = 0;
    Our_DR = 0;
    Our_UR = 0;
    Our_FI = 0;

    Buffer_Size = 512;               /* Set up defaults */
    B_Plus      = FALSE;             /* Not B Plus Protocol */
    Use_CRC     = FALSE;             /* Not CRC_16      */
    SA_Max      = 1;                 /* Single Packet send */
    Max_Inc      = 0;                 /* Multi Packet send Count */
    SA_Error_Count = 0;              /* No Upload errors yet */

    for( i = 0 ; i < sizeof(DQ_Minimal) ; i++ )
	Our_QS[i] = DQ_Minimal[i];

    p = &(SA_Buf[SA_Next_to_Fill]);
    p->buf [0] = '+';  /* Prepare to return Our own parameters */
    p->buf [1] = Def_WS;
    p->buf [2] = Def_WR;
    p->buf [3] = Def_BS;
    p->buf [4] = Def_CM;
    p->buf [5] = Def_DQ;
    p->buf [6] = 0;          /* No transport layer here */

    for ( i = 0 ; i <= 7 ; i++ )
	p->buf[i + 7] = DQ_Default[i];

    p->buf [15] = Def_DR;
    p->buf [16] = Def_UR;
    p->buf [17] = Def_FI;

    Update_Quote_Table (DQ_Full);   /* Send the + Packet w/ full quoting */
    if ( !send_Packet(17) )
	return;

    SA_Next_to_ACK = Incr_SA (SA_Next_to_ACK);
    SA_Waiting = SA_Waiting - 1;

    Clear_Quote_Table();
    Update_Quote_Table(Our_QS);

    if ( !Read_Packet(FALSE,TRUE) )
	return;

    Send_ACK();

    if ( R_buffer[0] != '+' )
	return;

    for ( i = R_Size + 1; i<=512; i++ )
	R_buffer [i] = 0;

    His_WS = R_buffer [1];     /* Pick out Initiator's parameters */
    His_WR = R_buffer [2];
    His_BS = R_buffer [3];
    His_CM = R_buffer [4];

    His_QS [0] = R_buffer [7];
    His_QS [1] = R_buffer [8];
    His_QS [2] = R_buffer [9];
    His_QS [3] = R_buffer [10];
    His_QS [4] = R_buffer [11];
    His_QS [5] = R_buffer [12];
    His_QS [6] = R_buffer [13];
    His_QS [7] = R_buffer [14];

    His_DR = R_buffer [15];
    His_UR = R_buffer [16];
    His_FI = R_buffer [17];

    Quote_Set_Present = (R_Size >= 14 ? TRUE:FALSE);

    Our_WR = His_WS < Def_WR ? His_WS:Def_WR;
    Our_WS = His_WR < Def_WS ? His_WR:Def_WS;
    Our_BS = His_BS < Def_BS ? His_BS:Def_BS;
    Our_CM = His_CM < Def_CM ? His_CM:Def_CM;
    Our_DR = His_DR < Def_DR ? His_DR:Def_DR;
    Our_UR = His_UR < Def_UR ? His_UR:Def_UR;
    Our_FI = His_FI < Def_FI ? His_FI:Def_FI;

    if ( Our_BS == 0 )
	Our_BS = 4;    /* Default */

    Buffer_Size = Our_BS * 128;
    B_Plus = TRUE;

    if ( Our_CM == 1 )
	Use_CRC = TRUE;

    if ( Our_WS != 0 )
	SA_Max = 2;

    Clear_Quote_Table();		/* Restore Our Quoting Set */
    if ( Quote_Set_Present )		/* Insert Initiator's Quote Set */
	Update_Quote_Table (His_QS);
    else
	Update_Quote_Table (Our_QS);
}

static	int	Chk_Connect()
{
    Send_ENQ();
    if ( !read_byte() || ch != dle )
	return TRUE;
    if ( !read_byte() || ch != '+' )
	return TRUE;
    if ( !read_byte() || ch != '+' )
	return TRUE;
    if ( !read_byte() || ch != dle )
	return TRUE;
    if ( !read_byte() || ch != '0' )
	return TRUE;
    return FALSE;
}
static	int	Connect_BP()
{
    int     n;

    seq_num = 0;
    SA_Next_to_ACK  = 0;    /* Initialize Send-ahead variables */
    SA_Next_to_Fill = 0;
    SA_Waiting      = 0;
    Packet_Received = FALSE;

    for ( n = 0 ; n < 5 ; n++ ) {
	if ( !Chk_Connect() ) {
	    Transport_Parameters();
	    return FALSE;
	}
    }
    return TRUE;
}

__off_t Extract_Size(char **str)
{
    int flag = 1;
    __off_t l = 0;
    char *p = *str;

    while ( *p == ' ' )
	p++;

    if ( *p == '-' ) {
	flag = (-1);
	p++;
    }

    while ( *p >= '0' && *p <= '9' )
	l = l * 10 + (*(p++) - '0');

    while ( *p == ' ' )
	p++;

    *str = p;
    return (l * flag);
}
time_t Extract_Time(time_t zone, char **str)
{
    int n, i;
    __off_t l;
    int year, month, mday;
    time_t t, d;
    char *p = *str;
    static const int MonthDays[2][13] = {
	{ 0, 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31 },
	{ 0, 31, 29, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31 },
    };

    l = Extract_Size(&p);
    mday  = (int)(l % 100); l /= 100;
    month = (int)(l % 100); l /= 100;
    year  = (int)l;

    t = (time_t)Extract_Size(&p);

    if ( year < 1993 || month < 1 || month > 12 || mday < 1 || mday > 31 )
	t = 0;
    else {
	i = (year % 4) == 0 && (year % 100 != 0 || year % 400 == 0 ? 1 : 0);
	d = (year - 1970) * 365 + (year - 1969) / 4;	// BUG !!!
	for ( n = 1 ; n < month ; n++ )
	    d += MonthDays[i][n];
	d += (mday - 1);
	d *= 86400L;
	t += d;
	t += zone;
    }

    *str = p;
    return t;
}
void Process_File_Information()
{
    char *p = R_buffer + 4;
    R_buffer[R_Size - 1] = '\0';
    R_FileSize = Extract_Size(&p);
    time_t zone = (time_t)(Extract_Size(&p) * 60);
    R_FileCTime = Extract_Time(zone, &p);
    R_FileMTime = Extract_Time(zone, &p);
    strncpy(R_TrueName, p + 1, *p & 255);
    R_TrueName[*p & 255] = '\0';
}

int	BP_send(File_Name,data_File,type)
char	*File_Name;
FILE	*data_File;
int	type;
{
    int	    n,i,ch;
    buf_type *p;
    char    *s;
    UNSIG   usr_CRC;
    __off_t l,File_Size;
    struct stat st;
    struct tm *tm;

#ifdef	DEBUG
    debug("BP_send '%s'\n", File_Name);
#endif

    if ( Connect_BP() )
	return(ERR);

    p = &SA_Buf [SA_Next_to_Fill];
    p->buf [0] = 'T';
    p->buf [1] = 'D';
    p->buf [2] = type;
    strcpy(&(p->buf[3]),File_Name);

    if ( !send_Packet(strlen(File_Name) + 3) )
	return(ERR);

    fseeko(data_File, 0L, SEEK_END);   	/* seek to end of file */
    File_Size = ftello(data_File);	/* how long is this file ? */
    fseeko(data_File, 0L, SEEK_SET);   	/* back to the start, ready to go */

    if ( Our_DR > 0 && !Get_ACK() && Packet_Received != FALSE ) {

        SA_Next_to_ACK = Incr_SA(SA_Next_to_ACK);
        SA_Waiting = SA_Waiting - 1;

	if ( R_buffer[0] == 'T' && R_buffer[1] == 'r' ) {
	    s = &(R_buffer[2]);
	    while ( *s == ' ' ) s++;
	    l = atoll(s);
	    while ( isdigit(*s) ) s++;
	    while ( *s == ' ' ) s++;
	    usr_CRC = atoi(s);
	    checksum = Init_CRC(0xffff);
	    while ( l > 0 && (ch = getc(data_File)) != EOF ) {
		checksum = Upd_CRC(ch);
		l--;
	    }

	    if ( checksum != usr_CRC ) {
		if ( Our_DR > 1 ) {
		    Send_ACK();
		    p = &SA_Buf [SA_Next_to_Fill];
		    p->buf [0] = 'T';
		    p->buf [1] = 'f';
		    if ( !send_Packet(1) )
			return(ERR);
		    if ( !SA_Flush() )
			return(ERR);
    		    fseeko(data_File, 0L, SEEK_SET);
		} else {
	    	    Send_Failure ("rFailed Resume");
		    return (ERR);
		}
	    } else {
		Send_ACK();
	    }
	} else {
	    Send_Failure ("EFile read failure");
	    return(ERR);
	}
    }

    if ( Our_FI > 0 ) {
	p = &SA_Buf [SA_Next_to_Fill];
	p->buf [0] = 'T';
	p->buf [1] = 'I';
	p->buf [2] = 'B';
	p->buf [3] = 0x00;
	n = 4;

	if ( stat(File_Name, &st) )
	    memcpy(&st, 0, sizeof(st));

	sprintf(&(p->buf[n]), "%qd 0 ", File_Size);
	while ( p->buf[n] != '\0' ) n++;

	tm = gmtime(&(st.st_ctime));
	sprintf(&(p->buf[n]), "%04d%02d%02d %d ",
		tm->tm_year + 1900, tm->tm_mon + 1, tm->tm_mday, 
		tm->tm_hour * (60 * 60) + tm->tm_min * 60 + tm->tm_sec);
	while ( p->buf[n] != '\0' ) n++;

	tm = gmtime(&(st.st_mtime));
	sprintf(&(p->buf[n]), "%04d%02d%02d %d ",
		tm->tm_year + 1900, tm->tm_mon + 1, tm->tm_mday, 
		tm->tm_hour * (60 * 60) + tm->tm_min * 60 + tm->tm_sec);
	while ( p->buf[n] != '\0' ) n++;

	p->buf [n++] = strlen(File_Name);
	strcpy(&(p->buf[n]),File_Name);
	while ( p->buf[n] != '\0' ) n++;

	if ( !send_Packet(n) )
	    return(ERR);
    }

    do {
	p = &SA_Buf [SA_Next_to_Fill];
	p->buf [0] = 'N';
	n = fread (&p->buf[1], 1, Buffer_Size, data_File);
	if ( n > 0 ) {
	    if ( !send_Packet(n) )
		return(ERR);
	}
    } while(n > 0);

    if ( ferror(data_File) != 0) {
	Send_Failure ("EFile read failure");
	return(ERR);
    }

    p = &SA_Buf [SA_Next_to_Fill];
    p->buf [0] = 'T';
    p->buf [1] = 'C';

    if ( !send_Packet(1) )
	return(ERR);

    if ( !SA_Flush() )
	return(ERR);

    return(FALSE);

} /* Send_File */

int	BP_recive(char *File_Name, int type)
{
    int     n;
    int	    status;
    buf_type *p;
    __off_t File_Size = 0L;
    struct utimbuf ut;
    FILE *fp = NULL;

#ifdef	DEBUG
    debug("BP_recive '%s'\n", File_Name);
#endif

    R_FileSize = 0;
    R_FileCTime = R_FileMTime = 0;
    R_TrueName[0] = '\0';

    if ( Connect_BP() )
	return(ERR);

    n = 0;
    p = &SA_Buf [SA_Next_to_Fill];
    p->buf [n++] = 'T';
    p->buf [n++] = 'U';
    p->buf [n++] = type;
    strcpy(&(p->buf[n]), basename(File_Name));
    while ( p->buf[n] != '\0' ) n++;

    if ( !send_Packet(n) )
	return(ERR);

    while ( TRUE ) {
	if ( Read_Packet (FALSE, FALSE) ) {
	    switch (R_buffer[0]) {
            case 'N' :
		if ( fp == NULL ) {
		    if ( File_Name[0] == '\0' )
			File_Name = "BPlusTempFile";
		    if ( (fp = fopen(File_Name, "w")) == NULL ) {
		        Send_Failure ("EFile Open failure");
		        return(ERR);
		    }
		}
		File_Size += (R_Size - 1);
		status = fwrite( &R_buffer[1], 1, R_Size - 1, fp );
		if ( (status != (R_Size - 1)) ) {
		    Send_Failure ("EWrite failure");
		    goto ERRRET;
                }
                Send_ACK();
                break;

            case 'T' :
		if (R_buffer[1] == 'I') {
		    Process_File_Information();
                    Send_ACK();
		    if ( fp == NULL && File_Name[0] == '\0' && 
				R_TrueName[0] != '\0' )
			File_Name = R_TrueName;
		} else if (R_buffer[1] == 'C') {
                    Send_ACK();
		    if ( fp != NULL )
			fclose(fp);
		    if ( R_FileCTime != 0 ) {
			ut.actime  = time(NULL);
			ut.modtime = R_FileMTime ? R_FileMTime : R_FileCTime;
			utime(File_Name, &ut);
		    }
                    return(FALSE);
		} else {
                    Send_Failure ("NInvalid T Packet");
		    goto ERRRET;
		}
                break;

	    case 'F' :
		Send_ACK();
		goto ERRRET;
	    }
	} else {
	    goto ERRRET;
	}
    }
    return(FALSE);

ERRRET:
    if ( fp != NULL )
	fclose(fp);
    return ERR;

} /* Receive_File */
